'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _readMol = require('./readMol');

var _readMol2 = _interopRequireDefault(_readMol);

var _readCdxml = require('./readCdxml');

var _readCdxml2 = _interopRequireDefault(_readCdxml);

var _mouseEvents = require('./mouseEvents');

var _Fragment = require('./Fragment');

var _Fragment2 = _interopRequireDefault(_Fragment);

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _positionFloatingHydrogens = require('./positionFloatingHydrogens');

var _positionFloatingHydrogens2 = _interopRequireDefault(_positionFloatingHydrogens);

var _create2MissingCanvases = require('./create2MissingCanvases');

var _create2MissingCanvases2 = _interopRequireDefault(_create2MissingCanvases);

var _helpers = require('./helpers');

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// An object can be anything: a node, a bond, or even an entire fragment!

// An object path goes like this:
// ['fragments', 3, 'nodes', 5]


function _pointerDownHandler(event) {

  var mousePos = (0, _mouseEvents.getMousePos)(this.refs.svg, event);
  var shiftKeyIsBeingPressed = event.shiftKey;

  this.setState(function (state) {

    mousePos.x += state.minX;
    mousePos.y += state.minY;

    var stateAssigns = {
      latestMouseDownPoint: mousePos,
      mouseIsDown: true,
      objects: _extends({}, state.objects, {
        fragments: state.objects.fragments.map(function (fragment) {
          return _extends({}, fragment, {
            nodes: fragment.nodes.map(function (node) {
              return _extends({}, node, {
                latestMouseDownXY: {
                  x: node.x,
                  y: node.y
                }
              });
            })
          });
        })
      })
    };

    if (shiftKeyIsBeingPressed) {
      var pathOfTheObjectBeingPointedAt = (0, _helpers.getPathOfTheObjectBeingPointedAt)(mousePos, state.objects);

      if (pathOfTheObjectBeingPointedAt) {

        if ((0, _helpers.arrayOfArraysIncludesArray)(state.pathsOfSelectedObjects, pathOfTheObjectBeingPointedAt)) {
          // We are hitting one of the selected objects
          return _extends({}, state, stateAssigns);
        }

        // We are hitting something unselected.
        // What we are hitting is selected in addition to the objects that have already been slected (if any)
        // because the Shift key is being pressed.
        return _extends({}, state, {
          pathsOfSelectedObjects: [].concat(state.pathsOfSelectedObjects, [pathOfTheObjectBeingPointedAt])
        }, stateAssigns);
      }
    } else {
      var _pathOfTheObjectBeingPointedAt = (0, _helpers.getPathOfTheObjectBeingPointedAt)(mousePos, state.objects);

      if (_pathOfTheObjectBeingPointedAt) {

        if ((0, _helpers.arrayOfArraysIncludesArray)(state.pathsOfSelectedObjects, _pathOfTheObjectBeingPointedAt)) {
          // We are hitting one of the selected objects
          return _extends({}, state, stateAssigns);
        }

        // We are hitting something unselected.
        // If any objects are selected, they are deselected
        // because the Shift key is not pressed.
        // What we are hitting is selected.
        return _extends({}, state, {
          pathsOfSelectedObjects: [_pathOfTheObjectBeingPointedAt]
        }, stateAssigns);
      }

      // We are hitting nowhere.
      return _extends({}, state, {
        pathsOfSelectedObjects: []
      }, stateAssigns);
    }

    return _extends({}, state, stateAssigns);
  });
}

function _pointerUpHandler(event) {

  var mousePos = (0, _mouseEvents.getMousePos)(this.refs.svg, event);

  this.setState(function (state) {

    mousePos.x += state.minX;
    mousePos.y += state.minY;

    // let hitFragmentIndex = undefined;
    // let hitNodeIndex = undefined;
    //
    // state.objects.fragments.forEach((fragment, fragmentIndex) => {
    //   fragment.nodes.forEach((node, nodeIndex) => {
    //     if (Math.abs(node.x - mousePos.x) < 20 && Math.abs(node.y - mousePos.y) < 20) {
    //       hitFragmentIndex = fragmentIndex;
    //       hitNodeIndex = nodeIndex;
    //     }
    //   });
    // });


    if (state.latestMouseDownPoint.x === mousePos.x && state.latestMouseDownPoint.y === mousePos.y) {}
    // We clicked and released the pointer button.

    // const pathOfTheObjectHavingBeenClicked = getPathOfTheObjectBeingPointedAt(mousePos, state.objects);
    //
    // if (pathOfTheObjectHavingBeenClicked) {
    //   return {
    //     ...state,
    //     pathsOfSelectedObjects: [
    //       pathOfTheObjectHavingBeenClicked
    //     ],
    //     mouseIsDown: false
    //   };
    // }
    //
    // // We clicked nowhere.
    // return {
    //   ...state,
    //   pathsOfSelectedObjects: [],
    //   mouseIsDown: false
    // };


    // return {
    //   ...state,
    //   objects: {
    //     ...state.objects,
    //     fragments: state.objects.fragments.map((fragment, fragmentIndex) => {
    //       return {
    //         ...fragment,
    //         nodes: fragment.nodes.map((node, nodeIndex) => {
    //           return {
    //             ...node,
    //             beingEdited: (fragmentIndex === hitFragmentIndex && nodeIndex === hitNodeIndex)
    //           };
    //         })
    //       };
    //     })
    //   }
    // };

    // if (typeof hitFragmentIndex !== 'undefined' && typeof hitNodeIndex !== 'undefined') {
    //   // we clicked on a node
    // }

    // No changes.
    return _extends({}, state, {
      mouseIsDown: false
    });;
  });
}

function _pointerMoveHandler(event) {

  var state = this.state;
  if (state.mouseIsDown && state.pathsOfSelectedObjects.length) {
    // Mouse is pressed and something is selected, so we are dragging
    // the selected objects.
    event.preventDefault();
  }

  var mousePos = (0, _mouseEvents.getMousePos)(this.refs.svg, event);
  this.setState(function (state) {

    mousePos.x += state.minX;
    mousePos.y += state.minY;

    if (state.mouseIsDown) {
      if (state.pathsOfSelectedObjects.length) {
        // Mouse is pressed and something is selected, so we are dragging
        // the selected objects.

        var newCanvasCache = [].concat(state.canvasCache);

        var newObjects = _extends({}, state.objects, {
          fragments: state.objects.fragments.map(function (fragment, fragmentIndex) {
            var newFragment = _extends({}, fragment, {
              nodes: fragment.nodes.map(function (node, nodeIndex) {
                if ((0, _helpers.arrayOfArraysIncludesArray)(state.pathsOfSelectedObjects, ['fragments', fragmentIndex, 'nodes', nodeIndex])) {
                  return _extends({}, node, {
                    x: mousePos.x - state.latestMouseDownPoint.x + node.latestMouseDownXY.x,
                    y: mousePos.y - state.latestMouseDownPoint.y + node.latestMouseDownXY.y
                  });
                }
                return _extends({}, node);
              }),
              bonds: fragment.bonds.map(function (bond) {
                return _extends({}, bond);
              })
            });

            (0, _positionFloatingHydrogens2.default)(newFragment);

            var newCs = (0, _create2MissingCanvases2.default)(newFragment.nodes, newCanvasCache);
            newCanvasCache = [].concat(newCanvasCache, newCs);

            // DETERMINING BOND POLYGONS IN THE new fragment !!!!! new !!!!!
            newFragment.nodes.forEach(function (node, nodeIndex) {
              var c = (0, _helpers.getCanvas)(node, newCanvasCache);
              if (!c) throw 'hmmmm';
              if (node.label) {
                (0, _helpers.cutBondsWithLabel)(nodeIndex, c.filledPixelsData, newFragment.nodes, newFragment.bonds);
              } else {
                (0, _helpers.cutBondsWithoutLabel)(nodeIndex, newFragment.nodes, newFragment.bonds);
              }
            });
            // DETERMINING BOND POLYGONS IN THE new fragment !!!!! new !!!!!

            return newFragment;
          })
        });

        // Because we have moved nodes, we need to determine hovered
        // objects using newObjects
        return _extends({}, state, {
          objects: newObjects,
          pathOfTheObjectBeingHoveredOver: (0, _helpers.getPathOfTheObjectBeingPointedAt)(mousePos, newObjects),
          canvasCache: newCanvasCache
        });
      }
    }

    return _extends({}, state, {
      pathOfTheObjectBeingHoveredOver: (0, _helpers.getPathOfTheObjectBeingPointedAt)(mousePos, state.objects)
    });
  });
  //
  // const mousePos = getMousePos(this.refs.svg, event);
  // console.log(mousePos);
  // console.log(this.state);
  //
  // this.setState(state => {
  //   return {
  //     ...state,
  //     // cursor: (Math.random() < 0.5 ? 'auto' : 'pointer'),
  //     objects: {
  //       ...state.objects,
  //       fragments: state.objects.fragments.map(fragment => ({
  //         ...fragment,
  //         nodes: fragment.nodes.map(node => ({
  //           ...node,
  //           hover: (node.x <= mousePos.x && mousePos.x < node.x + 6 && node.y <= mousePos.y && mousePos.y < node.y + 6)
  //         }))
  //       }))
  //     }
  //   };
  // })
}

var Canvas = function (_Component) {
  _inherits(Canvas, _Component);

  function Canvas(props) {
    _classCallCheck(this, Canvas);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      mode: 'VIEWING', // VIEWING, EDITING_LABEL, DRAGGING(?)
      modeData: {},
      // For VIEWING we have an empty modeData object.
      // For EDITING_LABEL we have pathOfTheObjectBeingEdited.
      // For DRAGGING we have an empty modeData object.

      // We render selection & hover halos underneath/below everything else
      pathsOfSelectedObjects: [
        // ['fragments', 1, 'bonds', 4]
      ],
      pathOfTheObjectBeingHoveredOver: undefined,

      latestMouseDownPoint: { // start drag point
        x: undefined,
        y: undefined
      },

      mouseIsDown: false,
      // cursor: 'auto',
      // toolSelected: 'SELECT',
      objects: {
        fragments: [{
          nodes: [],
          bonds: []
        }]
      },
      canvasCache: [
        // {
        //   label: 'C',
        //   focusCharacterRange: [0, atomLine.substring(31,34).trim().length], // one range per line
        //   focusLine: 0, // assuming one line
        //   filledPixelsData: Float32Array(flatten([[0, 0], [0, 1], ...])),
        //   labelOriginXRelativeToFocus: -5.345,
        //   labelOriginYRelativeToFocus: 1.435
        // }
      ],
      minX: 99999, // We will apply Math.min to it.
      minY: 99999, // We will apply Math.min to it.
      maxX: 0, // We will apply Math.max to it.
      maxY: 0 // We will apply Math.max to it.
    };

    _this.pointerUpHandler = _pointerUpHandler.bind(_this);
    _this.pointerDownHandler = _pointerDownHandler.bind(_this);
    _this.pointerMoveHandler = _pointerMoveHandler.bind(_this);
    return _this;
  }

  Canvas.prototype.componentWillUnmount = function componentWillUnmount() {
    this.refs.svg.removeEventListener('touchmove', this.pointerMoveHandler, { passive: false }, false);
  };

  Canvas.prototype.componentDidMount = function componentDidMount() {
    this.refs.svg.addEventListener('touchmove', this.pointerMoveHandler, { passive: false }, false);

    // this.placeMol(
    //   `\n\n\n 25 26  0  0001  0  0  0  0  0999 V2000\n    9.4638   -0.9375    0.0000 S   0  0  0  0  0  0  0  0  0  0  0\n   12.6690   -4.3708    0.0000 Na  0  3  0  0  0  0  0  0  0  0  0\n    5.7264   -3.3446    0.0000 O   0  0  0  0  0  0  0  0  0  0  0\n   11.2628   -4.3455    0.0000 O   0  5  0  0  0  0  0  0  0  0  0\n    9.1344   -5.4097    0.0000 O   0  0  0  0  0  0  0  0  0  0  0\n    4.5989   -2.6732    0.0000 O   0  0  0  0  0  0  0  0  0  0  0\n    8.1969   -2.6732    0.0000 N   0  0  0  0  0  0  0  0  0  0  0\n    5.7264   -0.6715    0.0000 N   0  0  0  0  0  0  0  0  0  0  0\n    8.1969   -1.3429    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    6.8666   -1.3429    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    9.4638   -3.0786    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    6.8666   -2.6732    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n   10.2619   -2.0017    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    9.9325   -4.3455    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n   11.1994   -2.9392    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n   11.1994   -1.0769    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    4.5989   -1.3429    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    3.4333   -0.6715    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    2.3058   -1.3429    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    1.1529   -0.6715    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    2.3058   -2.6732    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    0.0000   -1.3429    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    1.1529   -3.3320    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    0.0000   -2.6732    0.0000 C   0  0  0  0  0  0  0  0  0  0  0\n    8.1969    0.0000    0.0000 H   0  0  0  0  0  0  0  0  0  0  0\n  1  9  1  0\n  1 13  1  0\n  3 12  2  0\n  4 14  1  0\n  5 14  2  0\n  6 17  2  0\n  7  9  1  0\n  7 11  1  0\n  7 12  1  0\n 10  8  1  1\n  8 17  1  0\n  9 10  1  0\n  9 25  1  6\n 10 12  1  0\n 11 13  1  0\n 11 14  1  6\n 13 15  1  0\n 13 16  1  0\n 17 18  1  0\n 18 19  1  0\n 19 20  2  0\n 19 21  1  0\n 20 22  1  0\n 21 23  2  0\n 22 24  2  0\n 23 24  1  0\nM  CHG  2   2   1   4  -1\nM  END\n`,
    //   this.state
    // );
    this.placeCdxml('<?xml version="1.0" encoding="UTF-8" ?>\n<!DOCTYPE CDXML SYSTEM "http://www.cambridgesoft.com/xml/cdxml.dtd" >\n<CDXML\n CreationProgram="ChemDraw 14.0.0.117"\n Name="Untitled ACS Document 1996-4"\n BoundingBox="118 78.45 239.82 187.74"\n WindowPosition="0 0"\n WindowSize="0 -2147483648"\n WindowIsZoomed="yes"\n FractionalWidths="yes"\n InterpretChemically="yes"\n ShowAtomQuery="yes"\n ShowAtomStereo="no"\n ShowAtomEnhancedStereo="yes"\n ShowAtomNumber="no"\n ShowResidueID="no"\n ShowBondQuery="yes"\n ShowBondRxn="yes"\n ShowBondStereo="no"\n ShowTerminalCarbonLabels="no"\n ShowNonTerminalCarbonLabels="no"\n HideImplicitHydrogens="no"\n LabelFont="90"\n LabelSize="10"\n LabelFace="96"\n CaptionFont="4"\n CaptionSize="12"\n HashSpacing="2.70"\n MarginWidth="2"\n LineWidth="1"\n BoldWidth="4"\n BondLength="28.35"\n BondSpacing="12"\n ChainAngle="120"\n LabelJustification="Auto"\n CaptionJustification="Left"\n AminoAcidTermini="HOH"\n ShowSequenceTermini="yes"\n ShowSequenceBonds="yes"\n ResidueWrapCount="40"\n ResidueBlockCount="10"\n ResidueZigZag="yes"\n NumberResidueBlocks="no"\n PrintMargins="36 36 36 36"\n MacPrintInfo="0003000001200120000000000B6608A0FF84FF880BE309180367052703FC0002000001200120000000000B6608A0000100640064000000010001010100000001270F000100010000000000000000000000000002001901900000000000600000000000000000000100000000000000000000000000000000"\n ChemPropName=""\n ChemPropFormula="Chemical Formula: "\n ChemPropExactMass="Exact Mass: "\n ChemPropMolWt="Molecular Weight: "\n ChemPropMOverZ="m/z: "\n ChemPropAnalysis="Elemental Analysis: "\n ChemPropBoilingPt="Boiling Point: "\n ChemPropMeltingPt="Melting Point: "\n ChemPropCritTemp="Critical Temp: "\n ChemPropCritPres="Critical Pres: "\n ChemPropCritVol="Critical Vol: "\n ChemPropGibbs="Gibbs Energy: "\n ChemPropLogP="Log P: "\n ChemPropMR="MR: "\n ChemPropHenry="Henry&apos;s Law: "\n ChemPropEForm="Heat of Form: "\n ChemProptPSA="tPSA: "\n ChemPropCLogP="CLogP: "\n ChemPropCMR="CMR: "\n ChemPropLogS="LogS: "\n ChemPropPKa="pKa: "\n color="0"\n bgcolor="1"\n><colortable>\n<color r="1" g="1" b="1"/>\n<color r="0" g="0" b="0"/>\n<color r="1" g="0" b="0"/>\n<color r="1" g="1" b="0"/>\n<color r="0" g="1" b="0"/>\n<color r="0" g="1" b="1"/>\n<color r="0" g="0" b="1"/>\n<color r="1" g="0" b="1"/>\n</colortable><fonttable>\n<font id="3" charset="iso-8859-1" name="Arial"/>\n<font id="4" charset="iso-8859-1" name="Times New Roman"/>\n<font id="90" charset="iso-8859-1" name="Helvetica"/>\n</fonttable><page\n id="1472"\n BoundingBox="0 0 540 719.75"\n HeaderPosition="36"\n FooterPosition="36"\n PrintTrimMarks="yes"\n HeightPages="1"\n WidthPages="1"\n><fragment\n id="1435"\n BoundingBox="118 78.45 239.82 187.74"\n Z="26"\n><n\n id="1432"\n p="170.05 132.03"\n Z="27"\n Element="7"\n NumHydrogens="1"\n NeedsClean="yes"\n AS="N"\n><t\n p="166.65 135.71"\n BoundingBox="166.65 127.83 180.25 135.71"\n LabelJustification="Left"\n LabelAlignment="Left"\n><s font="3" size="9.4" face="96">NH</s></t></n><n\n id="1434"\n p="170.05 103.68"\n Z="28"\n Element="7"\n NumHydrogens="1"\n NeedsClean="yes"\n AS="N"\n><t\n p="166.65 107.36"\n BoundingBox="166.65 99.48 180.25 107.36"\n LabelJustification="Left"\n LabelAlignment="Left"\n><s font="3" size="9.4" face="96">NH</s></t></n><n\n id="1436"\n p="141.70 103.68"\n Z="29"\n/><n\n id="1438"\n p="141.70 132.03"\n Z="30"\n AS="N"\n/><n\n id="1444"\n p="194.60 117.86"\n Z="34"\n Element="7"\n NumHydrogens="1"\n NeedsClean="yes"\n AS="N"\n><t\n p="198 121.53"\n BoundingBox="184.40 113.66 198 121.53"\n LabelJustification="Right"\n Justification="Right"\n LabelAlignment="Right"\n><s font="3" size="9.4" face="96">NH</s></t></n><n\n id="1446"\n p="208.78 93.31"\n Z="35"\n/><n\n id="1448"\n p="184.22 79.13"\n Z="36"\n AS="N"\n/><n\n id="1454"\n p="184.22 156.59"\n Z="40"\n/><n\n id="1456"\n p="208.78 142.41"\n Z="41"\n AS="N"\n/><n\n id="1462"\n p="121.65 83.64"\n Z="45"\n Element="8"\n NumHydrogens="0"\n NeedsClean="yes"\n AS="N"\n><t\n p="118 87.31"\n BoundingBox="118 79.32 125.31 87.41"\n LabelJustification="Left"\n><s font="3" size="9.4" face="96">O</s></t></n><n\n id="1465"\n p="176.89 183.97"\n Z="47"\n Element="8"\n NumHydrogens="0"\n NeedsClean="yes"\n AS="N"\n><t\n p="173.24 187.64"\n BoundingBox="173.24 179.65 180.55 187.74"\n LabelJustification="Left"\n><s font="3" size="9.4" face="96">O</s></t></n><n\n id="1468"\n p="236.16 85.97"\n Z="49"\n Element="8"\n NumHydrogens="0"\n NeedsClean="yes"\n AS="N"\n><t\n p="232.51 89.64"\n BoundingBox="232.51 81.65 239.82 89.74"\n LabelJustification="Left"\n><s font="3" size="9.4" face="96">O</s></t></n><b\n id="1441"\n Z="31"\n B="1434"\n E="1436"\n BS="N"\n/><b\n id="1442"\n Z="32"\n B="1436"\n E="1438"\n BS="N"\n/><b\n id="1443"\n Z="33"\n B="1438"\n E="1432"\n BS="N"\n/><b\n id="1451"\n Z="37"\n B="1444"\n E="1446"\n BS="N"\n/><b\n id="1452"\n Z="38"\n B="1446"\n E="1448"\n BS="N"\n/><b\n id="1453"\n Z="39"\n B="1448"\n E="1434"\n BS="N"\n/><b\n id="1459"\n Z="42"\n B="1432"\n E="1454"\n BS="N"\n/><b\n id="1460"\n Z="43"\n B="1454"\n E="1456"\n BS="N"\n/><b\n id="1461"\n Z="44"\n B="1456"\n E="1444"\n BS="N"\n/><b\n id="1464"\n Z="46"\n B="1436"\n E="1462"\n Order="2"\n/><b\n id="1467"\n Z="48"\n B="1454"\n E="1465"\n Order="2"\n/><b\n id="1470"\n Z="50"\n B="1446"\n E="1468"\n Order="2"\n/></fragment></page></CDXML>', this.state);
    // this.setState(state => {
    //   return {
    //     ...state,
    //     pathsOfSelectedObjects: [
    //       ['fragments', 1, 'bonds', 4],
    //       ['fragments', 1, 'bonds', 3]
    //     ]
    //   };
    // });
  };

  Canvas.prototype.placeMol = function placeMol(mol, state) {

    var fragment = (0, _readMol2.default)(mol);

    var newCs = (0, _create2MissingCanvases2.default)(fragment.nodes, state.canvasCache);

    // DETERMINING BOND POLYGONS IN THE fragment
    fragment.nodes.forEach(function (node, nodeIndex) {
      var c = (0, _helpers.getCanvas)(node, [].concat(state.canvasCache, newCs));
      if (!c) throw 'hmmmm';
      if (node.label) {
        (0, _helpers.cutBondsWithLabel)(nodeIndex, c.filledPixelsData, fragment.nodes, fragment.bonds);
      } else {
        (0, _helpers.cutBondsWithoutLabel)(nodeIndex, fragment.nodes, fragment.bonds);
      }
    });
    // DETERMINING BOND POLYGONS IN THE fragment


    var newMinX = state.minX;
    var newMinY = state.minY;
    var newMaxX = state.maxX;
    var newMaxY = state.maxY;
    fragment.nodes.forEach(function (node) {
      var c = (0, _helpers.getCanvas)(node, [].concat(state.canvasCache, newCs));
      if (!c) throw 'hmmmm';
      newMinX = Math.min(newMinX, node.x + c.minX - _constants2.default.SVG_PADDING);
      newMinY = Math.min(newMinY, node.y + c.minY - _constants2.default.SVG_PADDING);
      newMaxX = Math.max(newMaxX, node.x + c.maxX + _constants2.default.SVG_PADDING);
      newMaxY = Math.max(newMaxY, node.y + c.maxY + _constants2.default.SVG_PADDING);
    });

    this.setState(function (state) {
      return _extends({}, state, {
        objects: _extends({}, state.objects, {
          fragments: [].concat(state.objects.fragments, [fragment])
        }),
        canvasCache: [].concat(state.canvasCache, newCs),
        minX: newMinX,
        minY: newMinY,
        maxX: newMaxX,
        maxY: newMaxY
      });
    });
  };

  Canvas.prototype.placeCdxml = function placeCdxml(cdxml, state) {

    var fragment = (0, _readCdxml2.default)(cdxml);

    var newCs = (0, _create2MissingCanvases2.default)(fragment.nodes, state.canvasCache);

    // DETERMINING BOND POLYGONS IN THE fragment
    fragment.nodes.forEach(function (node, nodeIndex) {
      var c = (0, _helpers.getCanvas)(node, [].concat(state.canvasCache, newCs));
      if (!c) throw 'hmmmm';
      if (node.label) {
        (0, _helpers.cutBondsWithLabel)(nodeIndex, c.filledPixelsData, fragment.nodes, fragment.bonds);
      } else {
        (0, _helpers.cutBondsWithoutLabel)(nodeIndex, fragment.nodes, fragment.bonds);
      }
    });
    // DETERMINING BOND POLYGONS IN THE fragment


    var newMinX = state.minX;
    var newMinY = state.minY;
    var newMaxX = state.maxX;
    var newMaxY = state.maxY;
    fragment.nodes.forEach(function (node) {
      var c = (0, _helpers.getCanvas)(node, [].concat(state.canvasCache, newCs));
      if (!c) throw 'hmmmm';
      newMinX = Math.min(newMinX, node.x + c.minX - _constants2.default.SVG_PADDING);
      newMinY = Math.min(newMinY, node.y + c.minY - _constants2.default.SVG_PADDING);
      newMaxX = Math.max(newMaxX, node.x + c.maxX + _constants2.default.SVG_PADDING);
      newMaxY = Math.max(newMaxY, node.y + c.maxY + _constants2.default.SVG_PADDING);
    });

    this.setState(function (state) {
      return _extends({}, state, {
        objects: _extends({}, state.objects, {
          fragments: [].concat(state.objects.fragments, [fragment])
        }),
        canvasCache: [].concat(state.canvasCache, newCs),
        minX: newMinX,
        minY: newMinY,
        maxX: newMaxX,
        maxY: newMaxY
      });
    });
  };

  Canvas.prototype.setLabel = function setLabel(fragmentIndex, nodeIndex, newLabel, state) {

    var oldFragment = state.objects.fragments[fragmentIndex];
    var newNodes = [].concat(oldFragment.nodes);
    newNodes[nodeIndex] = _extends({}, newNodes[nodeIndex], {
      label: newLabel
    });
    var newFragment = _extends({}, oldFragment, {
      nodes: newNodes
    });

    var newCs = (0, _create2MissingCanvases2.default)(newFragment.nodes, state.canvasCache);

    // DETERMINING BOND POLYGONS IN THE newFragment !!!! new !!!!!
    newFragment.nodes.forEach(function (node, nodeIndex) {
      var c = (0, _helpers.getCanvas)(node, [].concat(state.canvasCache, newCs));
      if (!c) throw 'hmmmm';
      if (node.label) {
        (0, _helpers.cutBondsWithLabel)(nodeIndex, c.filledPixelsData, newFragment.nodes, newFragment.bonds);
      } else {
        (0, _helpers.cutBondsWithoutLabel)(nodeIndex, newFragment.nodes, newFragment.bonds);
      }
    });
    // DETERMINING BOND POLYGONS IN THE newFragment !!!! new !!!!!


    var newFragments = state.objects.fragments;
    newFragments[fragmentIndex] = newFragment;
    this.setState(function (state) {
      return _extends({}, state, {
        objects: _extends({}, state.objects, {
          fragments: newFragments
        }),
        canvasCache: [].concat(state.canvasCache, newCs)
      });
    });
  };

  Canvas.prototype.renderSelectedObjectHalos = function renderSelectedObjectHalos(state) {

    // Returning an array of two elements: selection halos and hover halo
    return [state.pathsOfSelectedObjects.map(function (objectPath, objectPathIndex) {
      return (0, _helpers.getHaloFromObjectPath)(objectPath, objectPathIndex, false, state);
    }), state.pathOfTheObjectBeingHoveredOver && (0, _helpers.getHaloFromObjectPath)(state.pathOfTheObjectBeingHoveredOver, state.pathsOfSelectedObjects.length, true, state)];
  };

  Canvas.prototype.render = function render() {
    var _this2 = this;

    var state = this.state;

    return _react2.default.createElement(
      'div',
      { style: {
          position: 'relative',
          width: state.maxX - state.minX + 'px',
          height: state.maxY - state.minY + 'px',
          display: 'inline-block'
          //opacity: 0.05
        } },
      _react2.default.createElement(
        'svg',
        {
          viewBox: state.minX + ' ' + state.minY + ' ' + (state.maxX - state.minX) + ' ' + (state.maxY - state.minY),
          style: {
            position: 'absolute',
            top: '0',
            left: '0',
            cursor: state.pathOfTheObjectBeingHoveredOver ? 'pointer' : 'auto',
            width: state.maxX - state.minX + 'px',
            height: state.maxY - state.minY + 'px'
          },
          ref: 'svg',
          width: state.maxX - state.minX,
          height: state.maxY - state.minY,
          onMouseDown: this.pointerDownHandler,
          onMouseUp: this.pointerUpHandler,
          onMouseMove: this.pointerMoveHandler,
          onTouchStart: this.pointerDownHandler,
          onTouchEnd: this.pointerUpHandler
        },
        this.renderSelectedObjectHalos(state),
        state.objects.fragments.map(function (fragment, fragmentIndex) {
          return _react2.default.createElement(_Fragment2.default, {
            key: fragmentIndex,
            canvasCache: state.canvasCache,
            fragment: fragment
          });
        })
      ),
      state.objects.fragments.map(function (fragment, fragmentIndex) {
        return _react2.default.createElement(
          'div',
          { key: fragmentIndex, style: { position: 'absolute', top: '0', left: '0' } },
          fragment.nodes.map(function (node, nodeIndex) {
            if (!node.beingEdited) return;
            var c = (0, _helpers.getCanvas)(node, state.canvasCache);
            if (!c) return;
            return _react2.default.createElement(_Label2.default, {
              key: nodeIndex,
              origin: {
                x: node.x + c.labelOriginXRelativeToFocus,
                y: node.y + c.labelOriginYRelativeToFocus
              },
              onChange: function onChange(newLabel) {
                _this2.setLabel(fragmentIndex, nodeIndex, newLabel, state);
              },
              value: node.label
            });
          })
        );
      })
    );
  };

  return Canvas;
}(_react.Component);

exports.default = Canvas;