'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Node = require('./Node');

var _Node2 = _interopRequireDefault(_Node);

var _Bond = require('./Bond');

var _Bond2 = _interopRequireDefault(_Bond);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Fragment = function (_Component) {
  _inherits(Fragment, _Component);

  function Fragment() {
    _classCallCheck(this, Fragment);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Fragment.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement(
      'g',
      null,
      this.props.fragment.nodes.map(function (node, nodeIndex) {
        return _react2.default.createElement(_Node2.default, {
          key: nodeIndex,
          canvasCache: _this2.props.canvasCache,
          node: node
        });
      }),
      this.props.fragment.bonds.map(function (bond, bondIndex) {
        return _react2.default.createElement(_Bond2.default, {
          key: bondIndex,
          bond: bond,
          firstNode: _this2.props.fragment.nodes[bond.firstNodeIndex],
          secondNode: _this2.props.fragment.nodes[bond.secondNodeIndex]
        });
      })
    );
  };

  return Fragment;
}(_react.Component);

Fragment.propTypes = {
  canvasCache: _propTypes2.default.array.isRequired,
  fragment: _propTypes2.default.object.isRequired
};

exports.default = Fragment;