'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// We use contentEditable span and not input.
// Benefits of input:
// (a) no formatting,
// (b) always single line,
// (c) easier onChange handlers?
// Benefits of contentEditable:
// (a) stretches on demand,
// (b) we can house formatted content, i.e. it's future proofed

// Need to copy the way draft js handles onpaste (we don't want to paste
// formatted content), entities (our focus range is an entity)
// Use mutation observer (instead of onInput)?
var Label = function (_Component) {
  _inherits(Label, _Component);

  function Label() {
    _classCallCheck(this, Label);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Label.prototype.componentDidMount = function componentDidMount() {
    this.refs.span.textContent = this.props.value;
  };

  // componentDidUpdate(prevProps, prevState) {
  //
  //   const div = document.createElement('DIV');
  //   div.textContent = this.props.value;
  //
  //   if (this.refs.span.innerHTML !== div.innerHTML) {
  //     this.refs.span.innerHTML = div.innerHTML;
  //   }
  // }


  Label.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement(
      'div',
      { style: {
          position: 'absolute',
          left: this.props.origin.x + 'px',
          top: this.props.origin.y - 5 * _constants2.default.FONT_SIZE + 'px'
        } },
      _react2.default.createElement('span', {
        ref: 'span',
        style: {
          display: 'inline-block',
          padding: '10px 0',

          fontSize: _constants2.default.FONT_SIZE + 'px',

          opacity: '0.75',

          border: 'none',
          outline: 'none',
          appearance: 'none',
          WebkitAppearance: 'none',
          backgroundColor: 'transparent',
          font: _constants2.default.FONT_SIZE + 'px sans-serif',

          lineHeight: _constants2.default.FONT_SIZE + 'px',
          whiteSpace: 'nowrap'
        },
        onInput: function onInput() {
          _this2.props.onChange(_this2.refs.span.textContent);
        }
        // onKeyDown={() => {
        //   setTimeout(() => {
        //     this.props.onChange(this.refs.span.textContent);
        //   }, 1);
        // }}
        , contentEditable: true
      }),
      _react2.default.createElement('span', { style: {
          display: 'inline-block',
          height: 5 * _constants2.default.FONT_SIZE + 'px'
        } })
    );
  };

  return Label;
}(_react.Component);

Label.propTypes = {
  origin: _propTypes2.default.object.isRequired, // intersection of left edge and baseline
  onChange: _propTypes2.default.func.isRequired, // accepts one parameter which is new label
  value: _propTypes2.default.string.isRequired
};

exports.default = Label;