'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Node = function (_Component) {
  _inherits(Node, _Component);

  function Node() {
    _classCallCheck(this, Node);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Node.prototype.render = function render() {
    var c = (0, _helpers.getCanvas)(this.props.node, this.props.canvasCache);
    if (c) {
      // const width = Math.max(...c.filledPixels.map(xy => xy[0])) - Math.min(...c.filledPixels.map(xy => xy[0]));
      // const height = Math.max(...c.filledPixels.map(xy => xy[1])) - Math.min(...c.filledPixels.map(xy => xy[1]));
      return _react2.default.createElement(
        'g',
        { transform: 'translate(' + this.props.node.x + ' ' + this.props.node.y + ')' },
        _react2.default.createElement(
          'text',
          {
            style: {
              fill: 'black',
              font: _constants2.default.FONT_SIZE + 'px sans-serif',
              WebkitTouchCallout: 'none',
              WebkitUserSelect: 'none',
              KhtmlUserSelect: 'none',
              MozUserSelect: 'none',
              MsUserSelect: 'none',
              userSelect: 'none'
            },
            x: c.labelOriginXRelativeToFocus,
            y: c.labelOriginYRelativeToFocus
          },
          this.props.node.label
        )
      );
    }

    return _react2.default.createElement('rect', {
      x: this.props.node.x,
      y: this.props.node.y,
      width: 6,
      height: 6,
      style: {
        fill: 'red'
      }
    });
  };

  return Node;
}(_react.Component);

Node.propTypes = {
  canvasCache: _propTypes2.default.array.isRequired,
  node: _propTypes2.default.object.isRequired
};

exports.default = Node;