'use strict';

exports.__esModule = true;
exports.getSingleBondPath = getSingleBondPath;

var _helpers = require('./helpers');

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getSingleBondPath(bond, firstNode, secondNode) {
  var d = (0, _helpers.subtractPoints)(secondNode, firstNode);
  var length = Math.sqrt(d.x * d.x + d.y * d.y);
  var bondVerticalUnitVector = (0, _helpers.createPoint)(0 - d.y / length, d.x / length);

  var firstEndPath = void 0;
  if (firstNode.label) {
    firstEndPath = (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), bond.firstT)) + ' L ' + (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), bond.firstT));
  } else {
    firstEndPath = (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), bond.firstUpT)) + ' L ' + (0, _helpers.pointToPathString)(firstNode) + ' L ' + (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), bond.firstDownT));
  }

  var secondEndPath = void 0;
  if (secondNode.label) {
    secondEndPath = (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), bond.secondT)) + ' L ' + (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), bond.secondT));
  } else {
    secondEndPath = (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, -_constants2.default.BOND_BAR_WIDTH / 2)), bond.secondDownT)) + ' L ' + (0, _helpers.pointToPathString)(secondNode) + ' L ' + (0, _helpers.pointToPathString)((0, _helpers.slidePoint)((0, _helpers.addPoints)(firstNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), (0, _helpers.addPoints)(secondNode, (0, _helpers.scalePoint)(bondVerticalUnitVector, _constants2.default.BOND_BAR_WIDTH / 2)), bond.secondUpT));
  }

  return 'M ' + firstEndPath + ' L ' + secondEndPath + ' Z';
}