'use strict';

exports.__esModule = true;

// returns a fragment
exports.default = function (f) {
  f = f.split(/\r?\n/);

  var countsLine = f[3];

  var numberOfAtoms = Number(countsLine.substring(0, 3));
  var numberOfBonds = Number(countsLine.substring(3, 6));

  var fragment = {
    nodes: [],
    bonds: []
  };

  // reading the atom block
  for (var i = 4; i < 4 + numberOfAtoms; ++i) {
    var atomLine = f[i];

    var node = {
      x: Math.floor(Number(atomLine.substring(0, 10)) * 50 + 49999),
      y: Math.floor(-Number(atomLine.substring(10, 20)) * 50 + 49999),
      z: Math.floor(Number(atomLine.substring(20, 30)) * 50 + 49999),
      label: atomLine.substring(31, 34).trim() + 'H₂₂',
      focusCharacterRange: [0, atomLine.substring(31, 34).trim().length], //[1, 1+atomLine.substring(31,34).trim().length], // one range per line
      focusLine: 0, // assuming one line
      beingEdited: false,
      latestMouseDownXY: {
        x: undefined,
        y: undefined
      }
    };

    fragment.nodes.push(node);
  }

  // reading the bond block
  for (var _i = 4 + numberOfAtoms; _i < 4 + numberOfAtoms + numberOfBonds; ++_i) {
    var bondLine = f[_i];

    var bond = {
      firstNodeIndex: Number(bondLine.substring(0, 3)) - 1,
      secondNodeIndex: Number(bondLine.substring(3, 6)) - 1,
      type: Number(bondLine.substring(6, 9)),
      stereo: Number(bondLine.substring(9, 12))
    };

    fragment.bonds.push(bond);
  }

  return fragment;
};