import React, { Component } from 'react';
import PropTypes from 'prop-types';
import CONSTANTS from './constants';
import { subtractPoints, createPoint, slidePoint, addPoints, scalePoint } from './helpers';
import { getSingleBondPath } from './bond-routines';

class Bond extends Component {
  render() {

    const pathD = getSingleBondPath(this.props.bond, this.props.firstNode, this.props.secondNode);

    return (
      <path
        d={pathD}
        style={{
          fill: 'black'
        }}
      />
    );
  }
}

Bond.propTypes = {
  bond: PropTypes.object.isRequired,
  firstNode: PropTypes.object.isRequired,
  secondNode: PropTypes.object.isRequired
}

export default Bond;
