import React, { Component } from 'react';
import Node from './Node';
import Bond from './Bond';
import PropTypes from 'prop-types';

class Fragment extends Component {
  render() {
    return (
      <g>
        {this.props.fragment.nodes.map((node, nodeIndex) => (
          <Node
            key={nodeIndex}
            canvasCache={this.props.canvasCache}
            node={node}
          />
        ))}
        {this.props.fragment.bonds.map((bond, bondIndex) => (
          <Bond
            key={bondIndex}
            bond={bond}
            firstNode={this.props.fragment.nodes[bond.firstNodeIndex]}
            secondNode={this.props.fragment.nodes[bond.secondNodeIndex]}
          />
        ))}
      </g>
    );
  }
}

Fragment.propTypes = {
  canvasCache: PropTypes.array.isRequired,
  fragment: PropTypes.object.isRequired
}

export default Fragment;
