import React, { Component } from 'react';
import PropTypes from 'prop-types';
import CONSTANTS from './constants';
import { getCanvas } from './helpers';

class Node extends Component {
  render() {
    const c = getCanvas(this.props.node, this.props.canvasCache);
    if (c) {
      // const width = Math.max(...c.filledPixels.map(xy => xy[0])) - Math.min(...c.filledPixels.map(xy => xy[0]));
      // const height = Math.max(...c.filledPixels.map(xy => xy[1])) - Math.min(...c.filledPixels.map(xy => xy[1]));
      return (
        <g transform={`translate(${this.props.node.x} ${this.props.node.y})`}>
          {/* <rect
            x={Math.min(...c.filledPixels.map(xy => xy[0]))}
            y={Math.min(...c.filledPixels.map(xy => xy[1]))}
            width={width}
            height={height}
            style={{ fill: this.props.node.hover ? 'red' : 'black' }}
          /> */}
          <text
            style={{
              fill: 'black',
              font: `${CONSTANTS.FONT_SIZE}px sans-serif`,
              WebkitTouchCallout: 'none',
              WebkitUserSelect: 'none',
              KhtmlUserSelect: 'none',
              MozUserSelect: 'none',
              MsUserSelect: 'none',
              userSelect: 'none'
            }}
            x={c.labelOriginXRelativeToFocus}
            y={c.labelOriginYRelativeToFocus}
          >{this.props.node.label}</text>
          {/* <circle
            cx={0}
            cy={0}
            style={{ fill: 'yellow' }}
            r={3}
          /> */}
        </g>
      );
    }

    return (
      <rect
        x={this.props.node.x}
        y={this.props.node.y}
        width={6}
        height={6}
        style={{
          fill: 'red'
        }}
      />
    );
  }
}

Node.propTypes = {
  canvasCache: PropTypes.array.isRequired,
  node: PropTypes.object.isRequired
}

export default Node;
