// returns a fragment
export default (f) => {
	f = f.split(/\r?\n/);

	const countsLine = f[3];

	const numberOfAtoms = Number(countsLine.substring(0,3));
	const numberOfBonds = Number(countsLine.substring(3,6));

  const fragment = {
    nodes: [],
    bonds: []
  };

	// reading the atom block
	for (let i = 4; i < 4 + numberOfAtoms; ++i) {
		const atomLine = f[i];

    const node = {
      x: Math.floor(Number(atomLine.substring(0,10)) * 50 + 49999),
      y: Math.floor(- Number(atomLine.substring(10,20)) * 50 + 49999),
      z: Math.floor(Number(atomLine.substring(20,30)) * 50 + 49999),
      label: atomLine.substring(31,34).trim()+'H₂₂',
      focusCharacterRange: [0, atomLine.substring(31,34).trim().length], //[1, 1+atomLine.substring(31,34).trim().length], // one range per line
      focusLine: 0, // assuming one line
      beingEdited: false,
      latestMouseDownXY: {
        x: undefined,
        y: undefined
      }
    };

    fragment.nodes.push(node);
	}

	// reading the bond block
	for (let i = 4 + numberOfAtoms; i < 4 + numberOfAtoms + numberOfBonds; ++i) {
		const bondLine = f[i];

    const bond = {
      firstNodeIndex: Number(bondLine.substring(0,3)) - 1,
      secondNodeIndex: Number(bondLine.substring(3,6)) - 1,
      type: Number(bondLine.substring(6,9)),
      stereo: Number(bondLine.substring(9,12))
    };

    fragment.bonds.push(bond);
	}

  return fragment;
}
